﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr150_3
{
    // Базовый класс: 
    class Alpha
    {
        // Защищенный целочисленный массив: 
        protected int[] num;
        // Конструктор с одним аргументом: 
        public Alpha(int[] t)
        {
            // Присваивание значения полю: 
            num = t;
        }
        // Целочисленное свойство: 
        public int number
        {
            // Аксессор для считывания значения: 
            get
            {
                // Возвращает размер массива:
                return num.Length;
            }
        }
        // Целочисленный индексатор с целочисленным индексом: 
        public int this[int k]
        {
            // Аксессор для считывания значения: 
            get
            {
                return num[k];
            }
            // Аксессор для присваивания значения: 
            set
            {
                num[k] = value;
            }
        }
        // Переопределение метода ToString(): 
        public override string ToString()
        {
            // Текстовая переменная: 
            string txt = "|";
            // Формируется значение текстовой переменной: 
            for (int k = 0; k < num.Length; k++)
            {
                txt += num[k] + "|";
            }
            // Результат метода: 
            return txt;
        }
    }

    // Производный класс: 
    class Bravo : Alpha
    {
        // Защищенный символьный массив: 
        protected char[] symb;
        // Конструктор с двумя аргументами: 
        public Bravo(int[] t, string txt): base(t){
            // Присваивание значения полю: 
            // Создание массива на основе текстового аргумента: 
            symb = txt.ToCharArray();
        }
        // Символьный индексатор с символьным индексом: 
         public char this[char s] {
             // Аксессор для считывания значения: 
             get {
                 return symb[s - 'a'];
             }
             // Аксессор для присваивания значения: 
             set {
                 symb[s - 'a'] = (char)value;
             }
         }
        // Замещение свойства: 
        new public int[] number
        {
            // Аксессор для считывания значения: 
            get
            {
                int[] rez = {num.Length, symb.Length};
                // Возвращает размер массива:
                return rez;
            }
        }
    }

    // Класс с главным методом:
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание и инициализация массива:
            int[] numsA = { 1, 3, 5, 7, 6, 5, 4 };
            // Создание объекта:
            Alpha objA = new Alpha(numsA);
            // Проверка содержимого массива объекта:
            Console.WriteLine("Объект Alpha: ");
            Console.WriteLine(objA);
            Console.WriteLine("objA[2] = {0}", objA[2]);
            objA[2] = 200;
            Console.WriteLine("Измененное значение objA[2] = {0}", objA[2]);
            Console.WriteLine();
            int[] numsB = { 10, 30, 50 };
            // Создание объекта:
            Bravo objB = new Bravo(numsB,"KLMNOP");
            // Проверка содержимого объекта:
            Console.WriteLine("Объект Bravo: ");
            Console.WriteLine("objB[2] = {0}", objB[2]);
            objB[2] = 400;
            Console.WriteLine("Измененное значение objB[2] = {0}", objB[2]);
            // Индексирование объекта:
            objB['a'] = 'X';
            objB['d'] = 'Y';
            Console.WriteLine("objB[\'a\'] = " + objB['a']);
            Console.WriteLine("objB[\'d\'] = " + objB['d']);
            Console.WriteLine();
            int[] masB = objB.number;
            Console.WriteLine("objB.number = {0}, {1}", masB[0], masB[1]);
            Console.WriteLine();
            // Проверка содержимого массива объекта:
            Console.WriteLine(objB);
            // Задержка:
            Console.ReadLine();
        }
    }
}
